#pragma once

#define TOP_SCREEN_WIDTH 400
#define TOP_SCREEN_HEIGHT 240

#define BOTTOM_SCREEN_WIDTH 320
#define BOTTOM_SCREEN_HEIGHT 240

#define MAX_TEXTURES 1024

#define TEXTURE_BOTTOM_SCREEN_BG 1
#define TEXTURE_BOTTOM_SCREEN_TOP_BAR 2
#define TEXTURE_BOTTOM_SCREEN_TOP_BAR_SHADOW 3
#define TEXTURE_BOTTOM_SCREEN_BOTTOM_BAR 4
#define TEXTURE_BOTTOM_SCREEN_BOTTOM_BAR_SHADOW 5
#define TEXTURE_TOP_SCREEN_BG 6
#define TEXTURE_TOP_SCREEN_TOP_BAR 7
#define TEXTURE_TOP_SCREEN_TOP_BAR_SHADOW 8
#define TEXTURE_TOP_SCREEN_BOTTOM_BAR 9
#define TEXTURE_TOP_SCREEN_BOTTOM_BAR_SHADOW 10
#define TEXTURE_LOGO 11
#define TEXTURE_SELECTION_OVERLAY 12
#define TEXTURE_SCROLL_BAR 13
#define TEXTURE_BUTTON_SMALL 14
#define TEXTURE_BUTTON_LARGE 15
#define TEXTURE_PROGRESS_BAR_BG 16
#define TEXTURE_PROGRESS_BAR_CONTENT 17
#define TEXTURE_META_INFO_BOX 18
#define TEXTURE_META_INFO_BOX_SHADOW 19
#define TEXTURE_BATTERY_CHARGING 20
#define TEXTURE_BATTERY_0 21
#define TEXTURE_BATTERY_1 22
#define TEXTURE_BATTERY_2 23
#define TEXTURE_BATTERY_3 24
#define TEXTURE_BATTERY_4 25
#define TEXTURE_BATTERY_5 26
#define TEXTURE_WIFI_DISCONNECTED 27
#define TEXTURE_WIFI_0 28
#define TEXTURE_WIFI_1 29
#define TEXTURE_WIFI_2 30
#define TEXTURE_WIFI_3 31

enum {
    COLOR_TEXT = 0,
    COLOR_NAND,
    COLOR_SD,
    COLOR_GAME_CARD,
    COLOR_DS_TITLE,
    COLOR_IMPORTANT,
    COLOR_OUTDATED,
    MAX_COLORS
};

void screen_init();
void screen_exit();
void screen_set_base_alpha(u8 alpha);
u32 screen_allocate_free_texture();
void screen_load_texture(u32 id, void* data, u32 size, u32 width, u32 height, GPU_TEXCOLOR format, bool linearFilter);
void screen_load_texture_file(u32 id, const char* path, bool linearFilter);
void screen_load_texture_tiled(u32 id, void* tiledData, u32 size, u32 width, u32 height, GPU_TEXCOLOR format, bool linearFilter);
void screen_load_texture_screenshot(u32 id, gfxScreen_t screen);
void screen_unload_texture(u32 id);
void screen_get_texture_size(u32* width, u32* height, u32 id);
void screen_begin_frame();
void screen_end_frame();
void screen_select(gfxScreen_t screen);
void screen_draw_texture(u32 id, float x, float y, float width, float height);
void screen_draw_texture_crop(u32 id, float x, float y, float width, float height);
float screen_get_font_height(float scaleY);
void screen_get_string_size(float* width, float* height, const char* text, float scaleX, float scaleY);
void screen_get_string_size_wrap(float* width, float* height, const char* text, float scaleX, float scaleY, float wrapX);
void screen_draw_string(const char* text, float x, float y, float scaleX, float scaleY, u32 colorId, bool centerLines);
void screen_draw_string_wrap(const char* text, float x, float y, float scaleX, float scaleY, u32 colorId, bool centerLines, float wrapX);
